import * as _ethersproject_abi from '@ethersproject/abi';
import * as react_query from 'react-query';
import { PredefinedReadContractConfig } from '@0xflair/react-common';
import * as ethers from 'ethers';
import { BytesLike, Signer, BigNumberish } from 'ethers';
import * as _ethersproject_abstract_provider from '@ethersproject/abstract-provider';
import { ContractVersion } from '@0xflair/contracts-registry';
import { Provider } from '@ethersproject/providers';
import { ReadContractConfig, WriteContractConfig } from '@wagmi/core';

declare type Config$a = PredefinedReadContractConfig<Args$1> & {
    role?: BytesLike;
    address?: BytesLike;
};
declare type Args$1 = [role: BytesLike, address: BytesLike];
declare const useOzHasRole: ({ enabled, role, address, ...restOfConfig }: Config$a) => {
    readonly call: (overrides?: {
        args?: Args$1 | undefined;
    } | undefined) => Promise<any>;
    readonly data: boolean | undefined;
    readonly error: Error | null;
    readonly isError: boolean;
    readonly isLoading: boolean;
    readonly isSuccess: boolean;
    readonly isFetched: boolean;
    readonly isFetching: boolean;
    readonly isRefetching: boolean;
    readonly refetch: <TPageData>(options?: (react_query.RefetchOptions & react_query.RefetchQueryFilters<TPageData>) | undefined) => Promise<react_query.QueryObserverResult<_ethersproject_abi.Result, Error>>;
    readonly fetchStatus: react_query.FetchStatus;
    readonly isIdle: boolean;
    readonly status: "error" | "idle" | "loading" | "success";
    readonly internal: Pick<react_query.QueryObserverResult<unknown, unknown>, "isLoadingError" | "isRefetchError" | "dataUpdatedAt" | "errorUpdatedAt" | "failureCount" | "isFetchedAfterMount" | "isPaused" | "isPlaceholderData" | "isPreviousData" | "isStale" | "remove">;
};

declare const useOzOwner: (config: PredefinedReadContractConfig) => {
    readonly call: (overrides?: {
        args?: [] | undefined;
    } | undefined) => Promise<any>;
    readonly data: BytesLike | undefined;
    readonly error: Error | null;
    readonly isError: boolean;
    readonly isLoading: boolean;
    readonly isSuccess: boolean;
    readonly isFetched: boolean;
    readonly isFetching: boolean;
    readonly isRefetching: boolean;
    readonly refetch: <TPageData>(options?: (react_query.RefetchOptions & react_query.RefetchQueryFilters<TPageData>) | undefined) => Promise<react_query.QueryObserverResult<_ethersproject_abi.Result, Error>>;
    readonly fetchStatus: react_query.FetchStatus;
    readonly isIdle: boolean;
    readonly status: "error" | "idle" | "loading" | "success";
    readonly internal: Pick<react_query.QueryObserverResult<unknown, unknown>, "isLoadingError" | "isRefetchError" | "dataUpdatedAt" | "errorUpdatedAt" | "failureCount" | "isFetchedAfterMount" | "isPaused" | "isPlaceholderData" | "isPreviousData" | "isStale" | "remove">;
};

declare type Config$9 = Partial<ReadContractConfig> & {
    contractVersion?: ContractVersion;
    enabled?: boolean;
    contractAddress?: string;
    signerOrProvider?: Signer | Provider | null;
    role?: BytesLike;
    address?: BytesLike;
};
declare type ArgsType$7 = [role?: BytesLike, address?: BytesLike];
declare const useOzRoleGranter: ({ contractVersion, contractAddress, signerOrProvider, role, address, ...restOfConfig }: Config$9) => {
    readonly data: {
        readonly txResponse: _ethersproject_abstract_provider.TransactionResponse | undefined;
        readonly txReceipt: _ethersproject_abstract_provider.TransactionReceipt | undefined;
    };
    readonly error: Error | null;
    readonly isIdle: boolean;
    readonly isLoading: boolean;
    readonly isSuccess: boolean;
    readonly isError: boolean;
    readonly writeAndWait: (inputArgs?: ArgsType$7 | undefined, overrides?: Partial<ethers.CallOverrides | undefined>) => Promise<{
        response: _ethersproject_abstract_provider.TransactionResponse;
        receipt: _ethersproject_abstract_provider.TransactionReceipt;
    }>;
};

declare type Config$8 = Partial<ReadContractConfig> & {
    contractVersion?: ContractVersion;
    enabled?: boolean;
    contractAddress?: string;
    signerOrProvider?: Signer | Provider | null;
    role?: BytesLike;
    address?: BytesLike;
};
declare type ArgsType$6 = [role?: BytesLike, address?: BytesLike];
declare const useOzRoleRenouncer: ({ contractVersion, contractAddress, signerOrProvider, role, address, ...restOfConfig }: Config$8) => {
    readonly data: {
        readonly txResponse: _ethersproject_abstract_provider.TransactionResponse | undefined;
        readonly txReceipt: _ethersproject_abstract_provider.TransactionReceipt | undefined;
    };
    readonly error: Error | null;
    readonly isIdle: boolean;
    readonly isLoading: boolean;
    readonly isSuccess: boolean;
    readonly isError: boolean;
    readonly writeAndWait: (inputArgs?: ArgsType$6 | undefined, overrides?: Partial<ethers.CallOverrides | undefined>) => Promise<{
        response: _ethersproject_abstract_provider.TransactionResponse;
        receipt: _ethersproject_abstract_provider.TransactionReceipt;
    }>;
};

declare type Config$7 = Partial<ReadContractConfig> & {
    contractVersion?: ContractVersion;
    enabled?: boolean;
    contractAddress?: string;
    signerOrProvider?: Signer | Provider | null;
    role?: BytesLike;
    address?: BytesLike;
};
declare type ArgsType$5 = [role?: BytesLike, address?: BytesLike];
declare const useOzRoleRevoker: ({ contractVersion, contractAddress, signerOrProvider, role, address, ...restOfConfig }: Config$7) => {
    readonly data: {
        readonly txResponse: _ethersproject_abstract_provider.TransactionResponse | undefined;
        readonly txReceipt: _ethersproject_abstract_provider.TransactionReceipt | undefined;
    };
    readonly error: Error | null;
    readonly isIdle: boolean;
    readonly isLoading: boolean;
    readonly isSuccess: boolean;
    readonly isError: boolean;
    readonly writeAndWait: (inputArgs?: ArgsType$5 | undefined, overrides?: Partial<ethers.CallOverrides | undefined>) => Promise<{
        response: _ethersproject_abstract_provider.TransactionResponse;
        receipt: _ethersproject_abstract_provider.TransactionReceipt;
    }>;
};

declare type Config$6 = PredefinedReadContractConfig<Args> & {
    accountAddress?: BytesLike;
};
declare type Args = [accountAddress?: BytesLike];
declare const useERC20BalanceOf: ({ accountAddress, ...restOfConfig }: Config$6) => {
    readonly call: (overrides?: {
        args?: Args | undefined;
    } | undefined) => Promise<any>;
    readonly data: BigNumberish | undefined;
    readonly error: Error | null;
    readonly isError: boolean;
    readonly isLoading: boolean;
    readonly isSuccess: boolean;
    readonly isFetched: boolean;
    readonly isFetching: boolean;
    readonly isRefetching: boolean;
    readonly refetch: <TPageData>(options?: (react_query.RefetchOptions & react_query.RefetchQueryFilters<TPageData>) | undefined) => Promise<react_query.QueryObserverResult<_ethersproject_abi.Result, Error>>;
    readonly fetchStatus: react_query.FetchStatus;
    readonly isIdle: boolean;
    readonly status: "error" | "idle" | "loading" | "success";
    readonly internal: Pick<react_query.QueryObserverResult<unknown, unknown>, "isLoadingError" | "isRefetchError" | "dataUpdatedAt" | "errorUpdatedAt" | "failureCount" | "isFetchedAfterMount" | "isPaused" | "isPlaceholderData" | "isPreviousData" | "isStale" | "remove">;
};

declare const useERC20Decimals: (config: PredefinedReadContractConfig) => {
    readonly call: (overrides?: {
        args?: [] | undefined;
    } | undefined) => Promise<any>;
    readonly data: BigNumberish | undefined;
    readonly error: Error | null;
    readonly isError: boolean;
    readonly isLoading: boolean;
    readonly isSuccess: boolean;
    readonly isFetched: boolean;
    readonly isFetching: boolean;
    readonly isRefetching: boolean;
    readonly refetch: <TPageData>(options?: (react_query.RefetchOptions & react_query.RefetchQueryFilters<TPageData>) | undefined) => Promise<react_query.QueryObserverResult<_ethersproject_abi.Result, Error>>;
    readonly fetchStatus: react_query.FetchStatus;
    readonly isIdle: boolean;
    readonly status: "error" | "idle" | "loading" | "success";
    readonly internal: Pick<react_query.QueryObserverResult<unknown, unknown>, "isLoadingError" | "isRefetchError" | "dataUpdatedAt" | "errorUpdatedAt" | "failureCount" | "isFetchedAfterMount" | "isPaused" | "isPlaceholderData" | "isPreviousData" | "isStale" | "remove">;
};

declare const useERC20Name: (config: PredefinedReadContractConfig) => {
    readonly call: (overrides?: {
        args?: [] | undefined;
    } | undefined) => Promise<any>;
    readonly data: BytesLike | undefined;
    readonly error: Error | null;
    readonly isError: boolean;
    readonly isLoading: boolean;
    readonly isSuccess: boolean;
    readonly isFetched: boolean;
    readonly isFetching: boolean;
    readonly isRefetching: boolean;
    readonly refetch: <TPageData>(options?: (react_query.RefetchOptions & react_query.RefetchQueryFilters<TPageData>) | undefined) => Promise<react_query.QueryObserverResult<_ethersproject_abi.Result, Error>>;
    readonly fetchStatus: react_query.FetchStatus;
    readonly isIdle: boolean;
    readonly status: "error" | "idle" | "loading" | "success";
    readonly internal: Pick<react_query.QueryObserverResult<unknown, unknown>, "isLoadingError" | "isRefetchError" | "dataUpdatedAt" | "errorUpdatedAt" | "failureCount" | "isFetchedAfterMount" | "isPaused" | "isPlaceholderData" | "isPreviousData" | "isStale" | "remove">;
};

declare const useERC20Symbol: (config: PredefinedReadContractConfig) => {
    readonly call: (overrides?: {
        args?: [] | undefined;
    } | undefined) => Promise<any>;
    readonly data: BytesLike | undefined;
    readonly error: Error | null;
    readonly isError: boolean;
    readonly isLoading: boolean;
    readonly isSuccess: boolean;
    readonly isFetched: boolean;
    readonly isFetching: boolean;
    readonly isRefetching: boolean;
    readonly refetch: <TPageData>(options?: (react_query.RefetchOptions & react_query.RefetchQueryFilters<TPageData>) | undefined) => Promise<react_query.QueryObserverResult<_ethersproject_abi.Result, Error>>;
    readonly fetchStatus: react_query.FetchStatus;
    readonly isIdle: boolean;
    readonly status: "error" | "idle" | "loading" | "success";
    readonly internal: Pick<react_query.QueryObserverResult<unknown, unknown>, "isLoadingError" | "isRefetchError" | "dataUpdatedAt" | "errorUpdatedAt" | "failureCount" | "isFetchedAfterMount" | "isPaused" | "isPlaceholderData" | "isPreviousData" | "isStale" | "remove">;
};

declare const useERC20TotalSupply: (config: PredefinedReadContractConfig) => {
    readonly call: (overrides?: {
        args?: [] | undefined;
    } | undefined) => Promise<any>;
    readonly data: BigNumberish | undefined;
    readonly error: Error | null;
    readonly isError: boolean;
    readonly isLoading: boolean;
    readonly isSuccess: boolean;
    readonly isFetched: boolean;
    readonly isFetching: boolean;
    readonly isRefetching: boolean;
    readonly refetch: <TPageData>(options?: (react_query.RefetchOptions & react_query.RefetchQueryFilters<TPageData>) | undefined) => Promise<react_query.QueryObserverResult<_ethersproject_abi.Result, Error>>;
    readonly fetchStatus: react_query.FetchStatus;
    readonly isIdle: boolean;
    readonly status: "error" | "idle" | "loading" | "success";
    readonly internal: Pick<react_query.QueryObserverResult<unknown, unknown>, "isLoadingError" | "isRefetchError" | "dataUpdatedAt" | "errorUpdatedAt" | "failureCount" | "isFetchedAfterMount" | "isPaused" | "isPlaceholderData" | "isPreviousData" | "isStale" | "remove">;
};

declare type Config$5 = Partial<WriteContractConfig> & {
    contractVersion?: ContractVersion;
    enabled?: boolean;
    contractAddress?: string;
    signerOrProvider?: Signer | Provider | null;
    role?: BytesLike;
    to?: BytesLike;
    amount?: BigNumberish;
};
declare type ArgsType$4 = [to?: BytesLike, amount?: BigNumberish];
declare const useERC20Transfer: ({ contractVersion, contractAddress, signerOrProvider, role, to, amount, ...restOfConfig }: Config$5) => {
    readonly data: {
        readonly txResponse: _ethersproject_abstract_provider.TransactionResponse | undefined;
        readonly txReceipt: _ethersproject_abstract_provider.TransactionReceipt | undefined;
    };
    readonly error: Error | null;
    readonly isIdle: boolean;
    readonly isLoading: boolean;
    readonly isSuccess: boolean;
    readonly isError: boolean;
    readonly writeAndWait: (inputArgs?: ArgsType$4 | undefined, overrides?: Partial<ethers.CallOverrides | undefined>) => Promise<{
        response: _ethersproject_abstract_provider.TransactionResponse;
        receipt: _ethersproject_abstract_provider.TransactionReceipt;
    }>;
};

declare type Config$4 = Partial<ReadContractConfig> & {
    contractVersion?: ContractVersion;
    enabled?: boolean;
    contractAddress?: string;
    signerOrProvider?: Signer | Provider | null;
    role?: BytesLike;
    to?: BytesLike;
    amount?: BigNumberish;
};
declare type ArgsType$3 = [to?: BytesLike, amount?: BigNumberish];
declare const useERC20RoleBasedMint: ({ contractVersion, contractAddress, signerOrProvider, role, to, amount, ...restOfConfig }: Config$4) => {
    readonly data: {
        readonly txResponse: _ethersproject_abstract_provider.TransactionResponse | undefined;
        readonly txReceipt: _ethersproject_abstract_provider.TransactionReceipt | undefined;
    };
    readonly error: Error | null;
    readonly isIdle: boolean;
    readonly isLoading: boolean;
    readonly isSuccess: boolean;
    readonly isError: boolean;
    readonly writeAndWait: (inputArgs?: ArgsType$3 | undefined, overrides?: Partial<ethers.CallOverrides | undefined>) => Promise<{
        response: _ethersproject_abstract_provider.TransactionResponse;
        receipt: _ethersproject_abstract_provider.TransactionReceipt;
    }>;
};

declare const useERC721Name: (config: PredefinedReadContractConfig) => {
    readonly call: (overrides?: {
        args?: [] | undefined;
    } | undefined) => Promise<any>;
    readonly data: BytesLike | undefined;
    readonly error: Error | null;
    readonly isError: boolean;
    readonly isLoading: boolean;
    readonly isSuccess: boolean;
    readonly isFetched: boolean;
    readonly isFetching: boolean;
    readonly isRefetching: boolean;
    readonly refetch: <TPageData>(options?: (react_query.RefetchOptions & react_query.RefetchQueryFilters<TPageData>) | undefined) => Promise<react_query.QueryObserverResult<_ethersproject_abi.Result, Error>>;
    readonly fetchStatus: react_query.FetchStatus;
    readonly isIdle: boolean;
    readonly status: "error" | "idle" | "loading" | "success";
    readonly internal: Pick<react_query.QueryObserverResult<unknown, unknown>, "isLoadingError" | "isRefetchError" | "dataUpdatedAt" | "errorUpdatedAt" | "failureCount" | "isFetchedAfterMount" | "isPaused" | "isPlaceholderData" | "isPreviousData" | "isStale" | "remove">;
};

declare const useERC721Symbol: (config: PredefinedReadContractConfig) => {
    readonly call: (overrides?: {
        args?: [] | undefined;
    } | undefined) => Promise<any>;
    readonly data: BytesLike | undefined;
    readonly error: Error | null;
    readonly isError: boolean;
    readonly isLoading: boolean;
    readonly isSuccess: boolean;
    readonly isFetched: boolean;
    readonly isFetching: boolean;
    readonly isRefetching: boolean;
    readonly refetch: <TPageData>(options?: (react_query.RefetchOptions & react_query.RefetchQueryFilters<TPageData>) | undefined) => Promise<react_query.QueryObserverResult<_ethersproject_abi.Result, Error>>;
    readonly fetchStatus: react_query.FetchStatus;
    readonly isIdle: boolean;
    readonly status: "error" | "idle" | "loading" | "success";
    readonly internal: Pick<react_query.QueryObserverResult<unknown, unknown>, "isLoadingError" | "isRefetchError" | "dataUpdatedAt" | "errorUpdatedAt" | "failureCount" | "isFetchedAfterMount" | "isPaused" | "isPlaceholderData" | "isPreviousData" | "isStale" | "remove">;
};

declare type Config$3 = Partial<WriteContractConfig> & {
    contractVersion?: ContractVersion;
    enabled?: boolean;
    contractAddress?: string;
    signerOrProvider?: Signer | Provider | null;
    from?: BytesLike;
    to?: BytesLike;
    tokenId?: BigNumberish;
};
declare type ArgsType$2 = [from?: BytesLike, to?: BytesLike, tokenId?: BigNumberish];
declare const useERC721TransferFrom: ({ contractVersion, contractAddress, signerOrProvider, from, to, tokenId, ...restOfConfig }: Config$3) => {
    readonly data: {
        readonly txResponse: _ethersproject_abstract_provider.TransactionResponse | undefined;
        readonly txReceipt: _ethersproject_abstract_provider.TransactionReceipt | undefined;
    };
    readonly error: Error | null;
    readonly isIdle: boolean;
    readonly isLoading: boolean;
    readonly isSuccess: boolean;
    readonly isError: boolean;
    readonly writeAndWait: (inputArgs?: ArgsType$2 | undefined, overrides?: Partial<ethers.CallOverrides | undefined>) => Promise<{
        response: _ethersproject_abstract_provider.TransactionResponse;
        receipt: _ethersproject_abstract_provider.TransactionReceipt;
    }>;
};

declare type ArgsType$1 = [owner: string, operator: string];
declare type Config$2 = {
    owner?: BytesLike;
    operator?: BytesLike;
} & PredefinedReadContractConfig<ArgsType$1>;
declare const useERC721IsApprovedForAll: ({ owner, operator, enabled, ...rest }: Config$2) => {
    readonly call: (overrides?: {
        args?: ArgsType$1 | undefined;
    } | undefined) => Promise<any>;
    readonly data: BigNumberish | undefined;
    readonly error: Error | null;
    readonly isError: boolean;
    readonly isLoading: boolean;
    readonly isSuccess: boolean;
    readonly isFetched: boolean;
    readonly isFetching: boolean;
    readonly isRefetching: boolean;
    readonly refetch: <TPageData>(options?: (react_query.RefetchOptions & react_query.RefetchQueryFilters<TPageData>) | undefined) => Promise<react_query.QueryObserverResult<_ethersproject_abi.Result, Error>>;
    readonly fetchStatus: react_query.FetchStatus;
    readonly isIdle: boolean;
    readonly status: "error" | "idle" | "loading" | "success";
    readonly internal: Pick<react_query.QueryObserverResult<unknown, unknown>, "isLoadingError" | "isRefetchError" | "dataUpdatedAt" | "errorUpdatedAt" | "failureCount" | "isFetchedAfterMount" | "isPaused" | "isPlaceholderData" | "isPreviousData" | "isStale" | "remove">;
};

declare type Config$1 = Partial<WriteContractConfig> & {
    contractVersion?: ContractVersion;
    enabled?: boolean;
    contractAddress?: string;
    signerOrProvider?: Signer | Provider | null;
    operator?: BytesLike;
    approved?: boolean;
};
declare type ArgsType = [operator?: BytesLike, approved?: boolean];
declare const useERC721SetApprovalForAll: ({ contractVersion, contractAddress, signerOrProvider, operator, approved, ...restOfConfig }: Config$1) => {
    readonly data: {
        readonly txResponse: _ethersproject_abstract_provider.TransactionResponse | undefined;
        readonly txReceipt: _ethersproject_abstract_provider.TransactionReceipt | undefined;
    };
    readonly error: Error | null;
    readonly isIdle: boolean;
    readonly isLoading: boolean;
    readonly isSuccess: boolean;
    readonly isError: boolean;
    readonly writeAndWait: (inputArgs?: ArgsType | undefined, overrides?: Partial<ethers.CallOverrides | undefined>) => Promise<{
        response: _ethersproject_abstract_provider.TransactionResponse;
        receipt: _ethersproject_abstract_provider.TransactionReceipt;
    }>;
};

declare type Config = {
    contractAddress?: string;
    contractVersion?: ContractVersion;
    chainId?: number;
    enabled?: boolean;
    watch?: boolean;
    cacheOnBlock?: boolean;
    owner?: BytesLike;
    operator?: BytesLike;
    signerOrProvider?: Signer | Provider | null;
    writeOverrides?: WriteContractConfig['overrides'];
};
declare const useERC721Approver: ({ contractAddress, contractVersion, chainId, enabled, watch, cacheOnBlock, signerOrProvider, owner, operator, writeOverrides, }: Config) => {
    readonly data: {
        readonly txResponse: _ethersproject_abstract_provider.TransactionResponse | undefined;
        readonly txReceipt: _ethersproject_abstract_provider.TransactionReceipt | undefined;
        readonly isApprovedForAll: ethers.BigNumberish | undefined;
    };
    readonly error: Error | null;
    readonly isLoading: boolean;
    readonly fetchIsApprovedForAll: <TPageData>(options?: (react_query.RefetchOptions & react_query.RefetchQueryFilters<TPageData>) | undefined) => Promise<react_query.QueryObserverResult<_ethersproject_abi.Result, Error>>;
    readonly setApprovalForAll: (approved?: boolean) => Promise<void>;
};

declare const useERC721TotalSupply: (config: PredefinedReadContractConfig) => {
    readonly call: (overrides?: {
        args?: [] | undefined;
    } | undefined) => Promise<any>;
    readonly data: BigNumberish | undefined;
    readonly error: Error | null;
    readonly isError: boolean;
    readonly isLoading: boolean;
    readonly isSuccess: boolean;
    readonly isFetched: boolean;
    readonly isFetching: boolean;
    readonly isRefetching: boolean;
    readonly refetch: <TPageData>(options?: (react_query.RefetchOptions & react_query.RefetchQueryFilters<TPageData>) | undefined) => Promise<react_query.QueryObserverResult<_ethersproject_abi.Result, Error>>;
    readonly fetchStatus: react_query.FetchStatus;
    readonly isIdle: boolean;
    readonly status: "error" | "idle" | "loading" | "success";
    readonly internal: Pick<react_query.QueryObserverResult<unknown, unknown>, "isLoadingError" | "isRefetchError" | "dataUpdatedAt" | "errorUpdatedAt" | "failureCount" | "isFetchedAfterMount" | "isPaused" | "isPlaceholderData" | "isPreviousData" | "isStale" | "remove">;
};

export { useERC20BalanceOf, useERC20Decimals, useERC20Name, useERC20RoleBasedMint, useERC20Symbol, useERC20TotalSupply, useERC20Transfer, useERC721Approver, useERC721IsApprovedForAll, useERC721Name, useERC721SetApprovalForAll, useERC721Symbol, useERC721TotalSupply, useERC721TransferFrom, useOzHasRole, useOzOwner, useOzRoleGranter, useOzRoleRenouncer, useOzRoleRevoker };
